local assets=
{
	Asset("ANIM", "anim/sapphirespear.zip"),
	Asset("ANIM", "anim/sapphire_spear.zip"),
    Asset("ATLAS", "images/inventoryimages/sapphirespear.xml"),
}

local function applyupgrades(inst)

	local max_upgrades = 21
	local upgrades = math.min(inst.level, max_upgrades)
	inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(math.ceil(TUNING.SAPPHIRESPEAR_DAMAGE + upgrades))
	-- inst.components.talker:Say("Damage "..tostring(math.ceil(TUNING.SAPPHIRESPEAR_DAMAGE + upgrades)))
	-- if upgrades < 48 then
		-- inst.components.talker:Say("It's sharper!")
	-- elseif upgrades == 48 then
		-- inst.components.talker:Say("It reached its limit.")
	-- end
end

-- local function changelvl(inst, repair_item)
    -- local oldsection = self:GetUses()
	-- inst.level = inst.level + 1
-- end

local function onrepaired(inst, owner, repair_item)	
	inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/HUD_wet_open")
	inst.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	inst.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	if repair_item.prefab == "hail_ice" then
		-- local lvlchance = 1/16
		if math.random() < 1/16 then
			if inst.level < 21 then
				inst.components.talker:Say("It's sharper!")
				inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/iceboulder_smash")
			elseif inst.level >= 21 then
				inst.components.talker:Say("It reached its limit.")
			end
			inst.level = inst.level + 1
		end
	elseif repair_item.prefab == "ice" then
		if math.random() < 1/3 then
			if inst.level < 21 then
				inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/iceboulder_smash")
				inst.components.talker:Say("It's sharper!")
			elseif inst.level >= 21 then
				inst.components.talker:Say("It reached its limit.")
			end
		-- inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/iceboulder_smash")
			inst.level = inst.level + 1
		end
	elseif repair_item.prefab == "bluegem" then
		if inst.level < 21 then
			inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/iceboulder_smash")
			inst.components.talker:Say("It's sharper!")
		elseif inst.level >= 21 then
			inst.components.talker:Say("It reached its limit.")
		end
		inst.level = inst.level + 5
	end
	applyupgrades(inst)	
end

-- local function onrepaired(inst, owner, repair_item)	
	-- inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/HUD_wet_open")
	-- inst.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	-- inst.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	-- if repair_item.prefab == "hail_ice" then
		-- local lvlchance = 1/3
		-- if math.random() < lvlchance then
			-- if inst.level < 48 then
				-- inst.components.talker:Say("It's sharper!")
				-- inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/iceboulder_smash")
			-- elseif inst.level >= 48 then
				-- inst.components.talker:Say("It reached its limit.")
			-- end
			-- inst.level = inst.level + 1
		-- end
	-- elseif repair_item.prefab == "ice" then
		-- if inst.level < 48 then
			-- inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/iceboulder_smash")
			-- inst.components.talker:Say("It's sharper!")
		-- elseif inst.level >= 48 then
			-- inst.components.talker:Say("It reached its limit.")
		-- end
		-- inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/iceboulder_smash")
		-- inst.level = inst.level + 1
	-- elseif repair_item.prefab == "bluegem" then
		-- if inst.level < 48 then
			-- inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/iceboulder_smash")
			-- inst.components.talker:Say("It's sharper!")
		-- elseif inst.level >= 48 then
			-- inst.components.talker:Say("It reached its limit.")
		-- end
		-- inst.level = inst.level + 24
	-- end
	-- applyupgrades(inst)	
-- end

local function onpreload(inst, data)
	if data then
		if data.level then
			inst.level = data.level
			applyupgrades(inst)
		end
	end
end

local function onload(inst, data)
	applyupgrades(inst)	
end

local function onsave(inst, data)
	data.level = inst.level
end

local function onfinished(inst)
    inst:Remove()
end

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "sapphire_spear", "swap_spear")
	owner.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

local function fn()
	
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("spear")
    anim:SetBuild("sapphirespear")
    anim:PlayAnimation("idle")
    
    inst:AddTag("sharp")


    
    -------
    
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(TUNING.SAPPHIRESPEAR_USES)
    inst.components.finiteuses:SetUses(TUNING.SAPPHIRESPEAR_USES)
    
    inst.components.finiteuses:SetOnFinished( onfinished )
	
	inst:AddComponent("repairable")
	inst.components.repairable.repairmaterial = "ICE"
	inst.components.repairable.announcecanfix = false
	inst.components.repairable.onrepaired = onrepaired

    inst:AddComponent("inspectable")
	inst:AddComponent("weapon")
	inst.components.weapon:SetDamage(TUNING.SAPPHIRESPEAR_DAMAGE)
	
	inst:AddComponent("talker")
	inst.components.talker.fontsize = 30
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(1, 1, 1, 1)
    inst.components.talker.offset = Vector3(200,-250,0)
    -- inst.components.talker.symbol = "swap_object"

	
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/sapphirespear.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	inst.level = 0
	inst.OnSave = onsave
	inst.OnLoad = onload
	inst.OnPreLoad = onpreload
    
    return inst
end

return Prefab( "common/inventory/sapphirespear", fn, assets) 
